//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "mainfrm.h"
#include "edittown.h"
#include "SDL_math1.hpp"
#include "SDL_stringl.hpp"
/********************** set-up of include pathes ****************************
Please note: you have to set up the pathes to the include files before
this sample program can be compiled:
Use the command "Project/Options", select the "Directories/Conditional"
tab, and add the required packages to the "include path"

example:
   if you installed the packages into the default directory, the
   include path for the BasePack will be: "C:\SDLSuite\basepack\C6"

More information can be found in the following FAQ article:
   http://forum.sdlsuite.com/read.php?f=2&i=21&t=21
*****************************************************************************/
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SDL_GeoDB"
#pragma link "SDL_rchart"
#pragma link "SDL_replist"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DisplayZoom11()
{
RCMap->SetRange (1, 9.3, 46, 17.4, 49.5);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadGeoData()
{
TgdbPolygon  pg;
int          i, k;
int          cnt;
double       long1, lat1;
int          x1, y1;

RCMap->ClearGraf();
cnt = 0;
for (k=1; k<=GDB->NumEntries; k++)
  {
  switch (GDB->Data[k].ItemKind)
    {
    case gitBorder:
                {
                if (!(((GDB->Data[k].LatLow) < (RCMap->Scale1Y->RangeLow)) &&
                      ((GDB->Data[k].LatHigh) < (RCMap->Scale1Y->RangeLow))) ||
                     (((GDB->Data[k].LatLow) > (RCMap->Scale1Y->RangeHigh)) &&
                      ((GDB->Data[k].LatHigh) > (RCMap->Scale1Y->RangeHigh))) ||
                     (((GDB->Data[k].LongLow) < (RCMap->Scale1X->RangeLow)) &&
                      ((GDB->Data[k].LongHigh) < (RCMap->Scale1X->RangeLow))) ||
                     (((GDB->Data[k].LongLow) > (RCMap->Scale1X->RangeHigh)) &&
                      ((GDB->Data[k].LongHigh > RCMap->Scale1X->RangeHigh))))
                  {
                  if (GDB->RetrievePolygon(k, pg))
                    {
                    cnt = cnt + pg.Length+1;
                    RCMap->MoveTo(pg[0].Longit, pg[0].Latit);
                    for (i=pg.Low; i<pg.High; i++)
                      RCMap->DrawTo(pg[i].Longit, pg[i].Latit);
                    if (GDB->Data[k].Closed)
                      RCMap->DrawTo(pg[0].Longit, pg[0].Latit);
                    }
                  }
                break;
                }
    case gitTown:
                {
                if (!(((GDB->Data[k].LatLow) < (RCMap->Scale1Y->RangeLow)) ||
                        ((GDB->Data[k].LatLow) > (RCMap->Scale1Y->RangeHigh)) ||
                        ((GDB->Data[k].LongLow) < (RCMap->Scale1X->RangeLow)) ||
                        ((GDB->Data[k].LongLow) > (RCMap->Scale1X->RangeHigh))))
                  {
                  RCMap->MarkAt(GDB->Data[k].LongLow, GDB->Data[k].LatLow,8);
                  RCMap->R2M(1, GDB->Data[k].LongLow, GDB->Data[k].LatLow, x1, y1);
                  RCMap->M2R(1, x1, y1-10, long1, lat1);
                  RCMap->Text (long1, lat1, 8, GDB->Data[k].Name);
                  }
                break;
                }
    case gitBLOB:
                {
                if (! ((GDB->Data[k].LatHigh < RCMap->Scale1Y->RangeLow) ||
                       (GDB->Data[k].LatHigh > RCMap->Scale1Y->RangeHigh) ||
                       (GDB->Data[k].LongHigh < RCMap->Scale1X->RangeLow) ||
                       (GDB->Data[k].LongHigh > RCMap->Scale1X->RangeHigh)))
                  {
                  RCMap->MarkAt(GDB->Data[k].LongHigh, GDB->Data[k].LatHigh,12);
                  RCMap->Text (GDB->Data[k].LongHigh, GDB->Data[k].LatHigh, 8, GDB->Data[k].Name);
                  }
                break;
                }
    }
  }
RCMap->ShowGraf();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SBOpenDbClick(TObject *Sender)
{
ODiag1->Filter = "SDL Geo Database|*.sdlgds";
if (ODiag1->Execute())
  {
  GDB->DBName = ODiag1->FileName;
  LoadGeoData();
  DisplayZoom11();
  UpdateRLDB();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpdateRLDB()
{
const AnsiString Headers[13] = {
            "ItemId", "Name", "BlobOffset", "Class", "Tag", "ItemKind",
            "Closed", "CenterLat", "CenterLong",
            "LatLow", "LatHigh", "LongLow", "LongHigh"
            };

int  i;

RLDB->SuppressPaint = true;
for (i=0; i<13; i++)
  RLDB->Header[i+1] = Headers[i];
RLDB->NrOfRows = GDB->NumEntries;
for (i=1; i<=GDB->NumEntries; i++)
  {
  RLDB->Elem[2][i] = (ShortString) GDB->Data[i].Name;
  RLDB->Elem[1][i] = Decimal(GDB->Data[i].ItemId,5);
  RLDB->Elem[3][i] = Hex(GDB->Data[i].BlobOffset,8);
  RLDB->Elem[4][i] = IntToStr(GDB->Data[i].ClassFlag);
  RLDB->Elem[5][i] = IntToStr(GDB->Data[i].Tag);
  RLDB->Elem[6][i] = GDB_ITEMNAMES[GDB->Data[i].ItemKind];
  switch (GDB->Data[i].ItemKind)
    {
    case gitTown : {
                   RLDB->Elem[7][i] = "-";
                   RLDB->Elem[8][i] = strff(GDB->Data[i].LatLow,1,4);
                   RLDB->Elem[9][i] = strff(GDB->Data[i].LongLow,1,4);
                   RLDB->Elem[10][i] = "-";
                   RLDB->Elem[11][i] = "-";
                   RLDB->Elem[12][i] = "-";
                   RLDB->Elem[13][i] = "-";
                   break;
                   }
    case gitBorder:
                   {
                   RLDB->Elem[7][i] = BoolToStr(GDB->Data[i].Closed,3);
                   RLDB->Elem[10][i] = strff(GDB->Data[i].LatLow,1,4);
                   RLDB->Elem[11][i] = strff(GDB->Data[i].LatHigh,1,4);
                   RLDB->Elem[12][i] = strff(GDB->Data[i].LongLow,1,4);
                   RLDB->Elem[13][i] = strff(GDB->Data[i].LongHigh,1,4);
                   break;
                   }
    case gitBLOB : {
                   RLDB->Elem[7][i] = "-";
                   RLDB->Elem[8][i] = strff(GDB->Data[i].LatHigh,1,4);
                   RLDB->Elem[9][i] = strff(GDB->Data[i].LongHigh,1,4);
                   RLDB->Elem[10][i] = "-";
                   RLDB->Elem[11][i] = "-";
                   RLDB->Elem[12][i] = "-";
                   RLDB->Elem[13][i] = "-";
                   break;
                   }
    }
  }
RLDB->SuppressPaint = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EdSearchChange(TObject *Sender)
{
int      NextSearchPos;
TgdbName aname;

PageControl1->ActivePage = TSDb;
RLDB->SuppressPaint = true;
RLDB->DeselectAllRows();

NextSearchPos = -1;
while (NextSearchPos != 0) 
  {
  aname = EdSearch->Text;
  NextSearchPos = GDB->SearchData (aname, gitUndefined, NextSearchPos+1, 255);
  if (NextSearchPos > 0)
    RLDB->RowSelected[NextSearchPos] = true;
  }
RLDB->SuppressPaint = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
LoadGeoData();
DisplayZoom11();
UpdateRLDB();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SBDbEntryClick(TObject *Sender)
{
TSCoords Locat;

if (FrmEdTown->ShowModal() == mrOk)
  {
  Locat.Latit = FrmEdTown->NIOLat->Value;
  Locat.Longit = FrmEdTown->NIOLong->Value;
  GDB->AddTown(FrmEdTown->EdTownName->Text, Now(), 0, Locat, 0, 0, 0);
  LoadGeoData();
  UpdateRLDB();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DeleteselectedDBentries1Click(TObject *Sender)
{
int IxEntry;

IxEntry = GDB->GetClosestItemIDIx (int(RLDB->AsNumber[1][RLDB->Selection.Top]));
GDB->DeleteData(GDB->IxItemID[IxEntry].index);
LoadGeoData();
UpdateRLDB();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EditSelectedDBEntry1Click(TObject *Sender)
{
TSCoords  Locat;
int       IxEntry;
int       DbEntry;

IxEntry = GDB->GetClosestItemIDIx (int(RLDB->AsNumber[1][RLDB->Selection.Top]));
DbEntry = GDB->IxItemID[IxEntry].index;
if (GDB->Data[DbEntry].ItemKind != gitTown)
  {
  MessageDlg ("Sorry, cannot edit other data than towns", mtError, TMsgDlgButtons() << mbOK, 0);
  }
else
  {
  FrmEdTown->NIOLat->Value = GDB->Data[DbEntry].LatLow;
  FrmEdTown->NIOLong->Value = GDB->Data[DbEntry].LongLow;
  FrmEdTown->EdTownName->Text = GDB->Data[DbEntry].Name;
  if (FrmEdTown->ShowModal() == mrOk)
    {
    Locat.Latit = FrmEdTown->NIOLat->Value;
    Locat.Longit = FrmEdTown->NIOLong->Value;
    GDB->DeleteData(DbEntry);
    GDB->AddTown(FrmEdTown->EdTownName->Text, Now(), 0, Locat, 0, 0, 0);
    LoadGeoData();
    UpdateRLDB();
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Zoom111Click(TObject *Sender)
{
DisplayZoom11();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ZoomWindow1Click(TObject *Sender)
{
RCMap->MouseAction = maZoomWindPos;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Pan1Click(TObject *Sender)
{
RCMap->MouseAction = maPan;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RCMapZoomPan(TObject *Sender)
{
LoadGeoData();
}
//---------------------------------------------------------------------------

